#include <stdio.h>
#include "shared.h"

int IsProductionFinished(SharedStruct* sharedMem)
{
    int producedTotal = 0;
    int potentitalTotal = (sharedMem->producerCount)*100;
    for (int i = 0; i < 10; i++)
        producedTotal += sharedMem->count[i];
    return (producedTotal == potentitalTotal);
}

void PrintBuffer(SharedStruct* sharedMem)
{
    for (int i = 0; i < 10; i++)
        printf("Buffer slot %d: %d\n", i, sharedMem->buffer[i]);
    return;
}

void PrintNumberCount(SharedStruct* sharedMem)
{
    int consumedTotal = 0;
    for (int i = 0; i < 10; i++)
    {
        consumedTotal += sharedMem->count[i];
        printf("Number %d: %d time(s)\n", i, sharedMem->count[i]);
    }
    printf("Total produced: %d\n", (sharedMem->producerCount)*100);
    printf("Total consumed: %d\n", consumedTotal);
    return;
}

// Initializes the struct in shared memory
void SharedStructInit(SharedStruct* sharedMem, int producers, int consumers)
{
    for (int i = 0; i < 10; i++)
    {
        sharedMem->buffer[i] = -1;
        sharedMem->count[i] = 0;
    }
    sharedMem->producerCount = producers;
    sharedMem->consumerCount = consumers;
    sem_init(&sharedMem->mutex, 1, 1);
    sem_init(&sharedMem->empty, 1, producers+consumers);
    sem_init(&sharedMem->full, 1, 0);
}

// Takes array of letters and turns it into a number
int StringToNumber(char* argv)
{
    int splitAmount;
    sscanf(argv, "%d", &splitAmount);
    return splitAmount;
}
